// CDGeneral.cpp : implementation file
//

#include "stdafx.h"
#include "CDGeneral.h"
#include "..\UpDownClient.h"
#include "..\Server.h"
#include "..\emule.h"
#include "..\IP2Country.h"


// CCDGeneral dialog

IMPLEMENT_DYNCREATE(CCDGeneral, CPropertyPage)

CCDGeneral::CCDGeneral() : CPropertyPage(CCDGeneral::IDD)
{
	//{{AFX_DATA_INIT(CCDGeneral)
	//}}AFX_DATA_INIT

	m_hClientIcon = NULL;
	m_eCurrClientSoft = SO_LAST;
}

CCDGeneral::~CCDGeneral()
{
	if(m_hClientIcon != NULL)
	{
		::DestroyIcon(m_hClientIcon);
	}
}

void CCDGeneral::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCDGeneral)
	DDX_Control(pDX, IDC_USERNAME_VAL, m_ctrlUserName);
	DDX_Control(pDX, IDC_USERHASH_VAL, m_ctrlUserHash);
	DDX_Control(pDX, IDC_SERVERNAME_VAL, m_ctrlServerName);
	DDX_Control(pDX, IDC_SERVERIP_VAL, m_ctrlServerIP);
	DDX_Control(pDX, IDC_IPADDRESS_VAL, m_ctrlClientIP);
	DDX_Control(pDX, IDC_ID_VAL, m_ctrlClientID);
	DDX_Control(pDX, IDC_CLIENTSOFTWARE_VAL, m_ctrlClientSoftware);
	DDX_Control(pDX, IDC_CLIENTICON, m_ctrlClientIcon);
	DDX_Control(pDX, IDC_IDENTIFICATION_VAL, m_ctrlIdentification);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCDGeneral, CPropertyPage)
	//{{AFX_MSG_MAP(CCDGeneral)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CCDGeneral message handlers

BOOL CCDGeneral::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCDGeneral::Update()
{
	EMULE_TRY

	if(m_pClient == NULL)
		return;

	if(!::IsWindow(GetSafeHwnd()))
		return;

//	Reload icon only when client version is changed (e.g. Unknown->another)
	if (m_eCurrClientSoft != m_pClient->GetClientSoft())
	{
		m_eCurrClientSoft = m_pClient->GetClientSoft();
		if(m_hClientIcon != NULL)
		{
			::DestroyIcon(m_hClientIcon);
		}

		HINSTANCE hInst = AfxGetInstanceHandle();

		switch (m_eCurrClientSoft)
		{
			case SO_AMULE:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_AMULE32), IMAGE_ICON, 0, 0, 0));
				break;
			case SO_LMULE:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_LMULE32), IMAGE_ICON, 0, 0, 0));
				break;
			case SO_SHAREAZA:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_SHAREAZA32), IMAGE_ICON, 0, 0, 0));
				break;
			case SO_EDONKEYHYBRID:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_EDONKEYHYBRID32), IMAGE_ICON, 0, 0, 0));
				break;
			case SO_MLDONKEY:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_MLDONKEY32), IMAGE_ICON, 0, 0, 0));
				break;
			case SO_LPHANT:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_LPHANT32), IMAGE_ICON, 0, 0, 0));
				break;
			case SO_EMULE:
			case SO_OLDEMULE:
				if (m_pClient->m_pCredits->GetCurrentIdentState(m_pClient->GetIP()) != IS_IDENTIFIED)
				{
					m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_SECUREHASH32), IMAGE_ICON, 0, 0, 0));
				}
				else
				{
					m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_COMPROT32), IMAGE_ICON, 0, 0, 0));
				}
				break;
			case SO_EDONKEY:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_NORMAL32), IMAGE_ICON, 0, 0, 0));
				break;
			default:
				m_hClientIcon = reinterpret_cast<HICON>(::LoadImage(hInst, MAKEINTRESOURCE(IDI_UNKNOWN32), IMAGE_ICON, 0, 0, 0));
				break;
		}
		m_ctrlClientIcon.SetIcon(m_hClientIcon);
	}

	CString strBuffer = m_pClient->GetUserName();

	if(!strBuffer.IsEmpty())
	{
		m_ctrlUserName.SetWindowText(strBuffer);
	}
	else
	{
		m_ctrlUserName.SetWindowText(_T("?"));
	}
	
	bool bLoadedSourceName = false ;
	if(m_pClient->GetUserName())
	{
		bLoadedSourceName = (_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_LOADEDSOURCE)) != NULL) ||
							(_tcsstr(m_pClient->GetUserName(), ::GetResString(IDS_EXCHANGEDSOURCE)) != NULL) ;
	}

	if (m_pClient->HasValidHash() && !bLoadedSourceName)
	{
		char hashStr[MAX_HASHSTR_SIZE];

		md4str(m_pClient->GetUserHash(), hashStr);
		m_ctrlUserHash.SetWindowText(hashStr);
	}
	else
	{
		m_ctrlUserHash.SetWindowText(_T("?"));
	}

	m_ctrlClientSoftware.SetWindowText(m_pClient->GetClientNameAndVersionString());

	strBuffer.Format(_T("%u (%s)"), m_pClient->GetUserID(),
						::GetResString((m_pClient->HasLowID()) ? IDS_PRIOLOW : IDS_PRIOHIGH));
	m_ctrlClientID.SetWindowText(strBuffer);

	strBuffer.Format(_T("%s:%u"), m_pClient->GetFullIP(), m_pClient->GetUserPort());
	if (g_eMuleApp.m_pIP2Country->IsIP2Country())
		strBuffer.AppendFormat(_T(" (%s)"), m_pClient->GetCountryName());
	m_ctrlClientIP.SetWindowText(strBuffer);
	
	if(m_pClient->GetServerIP())
	{
		CString strPort;
		in_addr server;
		server.S_un.S_addr = m_pClient->GetServerIP();
		strBuffer.Format(_T("%s"), inet_ntoa(server));
		strPort.Format(":%u", m_pClient->GetServerPort());

		CServer* pServer = g_eMuleApp.m_pServerList->GetServerByAddress(strBuffer, m_pClient->GetServerPort()); 
		if(pServer)
		{
			if (g_eMuleApp.m_pIP2Country->IsIP2Country())
				strPort.AppendFormat(_T(" (%s)"), pServer->GetCountryName());
			m_ctrlServerName.SetWindowText(pServer->GetListName());
		}
		else
		{
			m_ctrlServerName.SetWindowText(_T("?"));
		}
		m_ctrlServerIP.SetWindowText(strBuffer + strPort);
	}
	else
	{
		m_ctrlServerIP.SetWindowText(_T("?"));
		m_ctrlServerName.SetWindowText(_T("?"));
	}

	if (m_pClient->Credits())
	{
		UINT		dwResStrId = IDS_IDENTNOSUPPORT;

		if (g_eMuleApp.m_pClientCreditList->CryptoAvailable())
		{
			switch (m_pClient->Credits()->GetCurrentIdentState(m_pClient->GetIP()))
			{
				case IS_NOTAVAILABLE:
				{
					break;
				}
				case IS_IDFAILED:
				case IS_IDNEEDED:
				case IS_IDBADGUY:
				{
					dwResStrId = IDS_IDENTFAILED;
					break;
				}
				case IS_IDENTIFIED:
				{
					dwResStrId = IDS_IDENTOK;
					break;
				}
			}
		}
		m_ctrlIdentification.SetWindowText(::GetResString(dwResStrId));
	}
	else
	{
		m_ctrlIdentification.SetWindowText(_T("?"));
	}

	EMULE_CATCH
}

void CCDGeneral::Localize(void)
{
	static const int s_aiResTbl[][2] =
	{
		{ IDC_USERHASH_LBL, IDS_CD_UHASH },
		{ IDC_IDENTIFICATION_LBL, IDS_CD_IDENT },
		{ IDC_CLIENTSOFTWARE_LBL, IDS_CD_CSOFT },
		{ IDC_CDG_IPADDRESS_LBL, IDS_CD_UIP },
		{ IDC_ID_LBL, IDS_CD_UID },
		{ IDC_SERVERNAME_LBL, IDS_CD_SNAME },
		{ IDC_SERVERIP_LBL, IDS_CD_SIP }
	};

	EMULE_TRY

	if (GetSafeHwnd())
	{
		for (uint32 i = 0; i < ELEMENT_COUNT(s_aiResTbl); i++)
			SetDlgItemText(s_aiResTbl[i][0], GetResString(static_cast<UINT>(s_aiResTbl[i][1])));
	}

	EMULE_CATCH
}
