// FileDetails.cpp : implementation file
//

#include "stdafx.h"
#include "..\emule.h"
#include "FileDetails.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileDetails

IMPLEMENT_DYNAMIC(CFileDetails, CPropertySheet)

CFileDetails::CFileDetails(UINT nIDCaption, CPartFile* pFile, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	Init(pFile);
}

CFileDetails::CFileDetails(LPCTSTR pszCaption, CPartFile* pFile, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	Init(pFile);
}

CFileDetails::~CFileDetails()
{
}

void CFileDetails::Init(CPartFile* pFile)
{	
	EMULE_TRY

	m_nTimer = 0;
	
	m_proppageGeneral.m_pFile = pFile;
	m_wndTransfer.m_pFile = pFile;
	m_wndSourceNames.m_pFile = pFile;
	m_wndAviInfo.m_pFile = pFile;
	m_wndParts.m_pFile = pFile;

	m_strGeneralTitle = GetResString(IDS_PW_GENERAL);
	m_proppageGeneral.m_psp.dwFlags |= PSP_USETITLE;
	m_proppageGeneral.m_pPSP->pszTitle = m_strGeneralTitle;

	m_strTransferTitle = GetResString(IDS_INFLST_USER_TRANSFER);
	m_wndTransfer.m_psp.dwFlags |= PSP_USETITLE;
	m_wndTransfer.m_pPSP->pszTitle = m_strTransferTitle;

	m_strSourceNamesTitle = GetResString(IDS_INFLST_FILE_SOURCENAMES);
	m_wndSourceNames.m_psp.dwFlags |= PSP_USETITLE;
	m_wndSourceNames.m_pPSP->pszTitle = m_strSourceNamesTitle;

#if 0	// not working by now
	m_strPartsTitle = GetResString(IDS_UP_PARTS);
	m_wndParts.m_psp.dwFlags |= PSP_USETITLE;
	m_wndParts.m_pPSP->pszTitle = m_strPartsTitle;
#endif

	AddPage(&m_proppageGeneral);
	AddPage(&m_wndTransfer);
	AddPage(&m_wndSourceNames);
	
	if (pFile && pFile->IsAviMovie())
	{
		m_strAviInfoTitle = GetResString(IDS_FD_AVIINFO);
		m_wndAviInfo.m_psp.dwFlags |= PSP_USETITLE;
		m_wndAviInfo.m_pPSP->pszTitle = m_strAviInfoTitle;

		AddPage(&m_wndAviInfo);
	}

//	AddPage(&m_wndParts);	// not working by now

	EMULE_CATCH
}

BEGIN_MESSAGE_MAP(CFileDetails, CPropertySheet)
	//{{AFX_MSG_MAP(CFileDetails)
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDetails message handlers

BOOL CFileDetails::OnInitDialog()
{
	CPropertySheet::OnInitDialog();
	
	Localize();
	m_nTimer = SetTimer(301, 15000, 0);

	return true;
}

void CFileDetails::OnTimer(UINT nIDEvent)
{
	if(nIDEvent == m_nTimer)
	{
		Update();
	}

	CPropertySheet::OnTimer(nIDEvent);
}

void CFileDetails::Update()
{
	m_proppageGeneral.Update();
	m_wndTransfer.Update();
	m_wndSourceNames.Update();

//	m_wndParts.Update();
}

void CFileDetails::Localize()
{
	if(GetSafeHwnd())
	{
	//	Property pages are localized on their creation (when user activate them)

//		m_wndParts.Localize();
	}
}

void CFileDetails::OnDestroy()
{
	if(m_nTimer != 0)
	{
		KillTimer(m_nTimer);
	}

	CPropertySheet::OnDestroy();
}
