#pragma once

#include "preferences.h"
#include "afxwin.h"

// CPPgServer dialog

class CPPgServer : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgServer)

public:
	CPPgServer();
	virtual ~CPPgServer();

	void SetPrefs(CPreferences* in_prefs) {	m_pPrefs = in_prefs; }

	// Dialog Data
	enum { IDD = IDD_PPG_SERVER };
protected:
	CPreferences *m_pPrefs;

	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
private:
	void LoadSettings(void);
public:
	virtual BOOL OnApply();
	
	afx_msg void OnEnChangeSrvConTimeout()			{ SetModified(); }
	afx_msg void OnEnChangeServerKeepAliveTimeout()	{ SetModified(); }
	afx_msg void OnEnChangeServerretries()			{ SetModified(); }
	afx_msg void OnBnClickedRemovedead();
	afx_msg void OnBnClickedAutoserver()			{ SetModified(); }
	afx_msg void OnBnClickedUpdateserverconnect()	{ SetModified(); }
	afx_msg void OnBnClickedScore()					{ SetModified(); }
	afx_msg void OnBnClickedRestartWaiting()		{ SetModified(); }
	afx_msg void OnBnClickedFastConnect()			{ SetModified(); }
	afx_msg void OnBnClickedSmartIdCheck()			{ SetModified(); }
	afx_msg void OnBnClickedAutoconnect()			{ SetModified(); }
	afx_msg void OnBnClickedReconn()				{ SetModified(); }
	afx_msg void OnBnClickedStaticOnly()			{ SetModified(); }
	afx_msg void OnBnClickedManualHighPrio()		{ SetModified(); }
	afx_msg void OnBnClickedUseAuxPortCheckbox()	{ SetModified();  }
	afx_msg void OnSetURLsForICC();
	void Localize(void);
protected:
	BOOL removeDead;
	BOOL autoServer;
	BOOL smartId;
	BOOL updateServerConnect;
	BOOL autoConnect;
	BOOL autoConnectStatic;
	BOOL reconnect;
	BOOL scoreSystem;
	BOOL manualServerHighPriority;
	CString serverConnectTimeout;
	CString serverKeepAliveTimeout;
	CString serverRetries;
	BOOL restartWaiting;
	BOOL m_bUseAuxPort;
private:
	CEdit serverConnectTimeoutEdit;
	CEdit serverKeepAliveTimeoutEdit;
	CEdit serverRetriesEdit;
	CString serverConTimeoutDesc;
	CString srvSecDesc;
	CString srvMinDesc;
	CButton removeDeadCheck;
	CString retriesDesc;
	CString serverKeepAliveTimeoutDesc;
	CButton autoServerCheck;
	CButton smartIdCheck;
	CButton scoreCheck;
	CButton restartWaitingCheck;
	CButton autoConnectCheck;
	CButton updateServerConnectCheck;
	CButton reconnCheck;
	CButton manualSrvHighCheck;
	CButton autoConnectStaticCheck;
	CButton urlsButton;
	CButton m_btnUseAuxPortCheck;
};
