#pragma once
#include "ServerList.h"
#include "server.h"
#include "TitleMenu.h"
#include "MuleListCtrl.h"
#include "Loggable.h"

enum ServerListColumns
{
	SL_COLUMN_SERVERNAME = 0,
	SL_COLUMN_SERVERIP,
	SL_COLUMN_DESCRIPTION,
	SL_COLUMN_PING,
	SL_COLUMN_NUMUSERS,
	SL_COLUMN_NUMFILES,
	SL_COLUMN_PREFERENCES,
	SL_COLUMN_FAILEDCOUNT,
	SL_COLUMN_STATIC,
	SL_COLUMN_SOFTFILELIMIT,
	SL_COLUMN_SOFTWAREVER,
	SL_COLUMN_COUNTRY,

	SL_COLUMN_NUMCOLUMNS
};

// CServerListCtrl
class CServerList;

class CServerListCtrl : public CMuleListCtrl, public CLoggable
{
	DECLARE_DYNAMIC(CServerListCtrl)

protected:
	bool			m_bSortAscending[SL_COLUMN_NUMCOLUMNS + 2];

private:
	CServerList	   *m_pServerList;

public:
					CServerListCtrl();
	virtual		   ~CServerListCtrl();
	bool			Init(CServerList *pServerList);
	bool			AddServer(CServer *pServer,bool bAddToList = true, bool bulkLoad = false, bool bChangeServerInfo = false);
	void			RemoveServer(CServer *pServer,bool bDelToList = true);
	void			RefreshServer(CServer& server);
	void			RefreshAllServer();
	void			RemoveDeadServer();
	void			SortFirstInit();
	void			SortInit(int sortCode);
	void			Localize();
	void			ShowFilesCount();
	int				FindIndex(const CServer *pServer) const;

//	Purity (moved from private to public because of the web server)
	bool			StaticServerFileAppend(CServer *pServer);
	bool			StaticServerFileRemove(CServer *pServer);

	CServer		   *GetServerAt(int iIndex) { return reinterpret_cast<CServer*>(GetItemData(iIndex)); }
	CServer		   *GetSelectedServer() { return GetServerAt(GetSelectionMark()); }
	CImageList		m_imageList;

protected:
	afx_msg	void	OnLvnColumnclickServlist(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void	OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void	OnNMLdblclk (NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void	OnDestroy();
	static	int		CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	virtual BOOL	OnCommand(WPARAM wParam,LPARAM lParam );

	DECLARE_MESSAGE_MAP()

private:
	void			AppendServer(CServer *pServer);
	void			RefreshServerDesc(int iIndex, const CServer& server);
};
