// Ini2.h: Ini-File-Interface by bond006 <rene.landgrebe@gmx.de>
// ****************************************************************
// This new interface replaces the old interface which was too slow
// Last Update: 08/24/2003

#pragma once
#include "types.h"

class CIni : public CFile
{
	public:
		CIni(const CString& strFileName);
		~CIni();

		void		CloseWithoutSave(){CloseFile();}
		void		SaveAndClose();

		void		AddCategory(const CString& strCategoryName);
		void		SetDefaultCategory(const CString& strCategoryName);
		void		DeleteCategory(const CString& strCategoryName);
		void		DeleteEntry(const CString& strCategoryName, const CString& strEntryName);

		CString		GetString(const CString& strEntryName, const CString& defValue, const CString& strCategoryName=_T(""));
		double		GetDouble(const CString& strEntryName, double defValue, const CString& strCategoryName=_T(""));
		float		GetFloat(const CString& strEntryName, float defValue, const CString& strCategoryName=_T(""));
		int			GetInt(const CString& strEntryName, int defValue, const CString& strCategoryName=_T(""));
		WORD		GetWORD(const CString& strEntryName, WORD defValue, const CString& strCategoryName=_T(""));
		uint32		GetUInt32(const CString& strEntryName, uint32 defValue, const CString& strCategoryName=_T(""));
		uint64		GetUInt64(const CString& strEntryName, uint64 defValue, const CString& strCategoryName=_T(""));
		bool		GetBool(const CString& strEntryName, bool defValue, const CString& strCategoryName=_T(""));
		void		SetString(const CString& strEntryName, const CString& strValue, const CString& strCategoryName=_T(""));
		void		SetDouble(const CString& strEntryName, double dValue, const CString& strCategoryName=_T(""));
		void		SetFloat(const CString& strEntryName, float fValue, const CString& strCategoryName=_T(""));
		void		SetInt(const CString& strEntryName, int nValue, const CString& strCategoryName=_T(""));
		void		SetWORD(const CString& strEntryName, WORD wValue, const CString& strCategoryName=_T(""));
		void		SetUInt32(const CString& strEntryName, uint32 nValue, const CString& strCategoryName=_T(""));
		void		SetUInt64(const CString& strEntryName, uint64 nValue, const CString& strCategoryName=_T(""));
		void		SetBool(const CString& strEntryName, bool bValue, const CString& strCategoryName=_T(""));

		void		GetArray(CString* pString, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		GetArray(double* pDouble, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		GetArray(float* pFloat, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		GetArray(int* pInt, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		GetArray(WORD* pWord, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		GetArray(bool* pBool, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		SetArray(CString* pString, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		SetArray(double* pDouble, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		SetArray(float* pFloat, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		SetArray(int* pInt, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		SetArray(WORD* pWord, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));
		void		SetArray(bool* pBool, int nElements, const CString& strEntryName, const CString& strCategoryName=_T(""));

		bool		CategoryExist(const CString& strCategoryName);
		bool		EntryExist(const CString& strCategoryName, const CString& strEntryName);
		bool		ValueExist(const CString& strCategoryName, const CString& strEntryName);

	private:
		void		OpenFile();
		void		CloseFile();
		void		ReadData();

		void		SetValue(const CString& strCategoryName, const CString& strEntryName, const CString& strValue);
		CString		GetValue(const CString& strCategoryName, const CString& strEntryName);

		CString m_strDefCategory;
		CString m_strFileBuffer;
		CString m_strFileName;
};